## mingw-w64-gr-0.73.7-1.src.tar.zst

=== 3rdparty/bzip2/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

  CFLAGS = -O -I. -fPIC -fno-common $(ARCHS)
ifeq ($(shell uname),Darwin)
 CFLAGS += -mmacosx-version-min=10.15
endif
    OBJS = blocksort.o \
        huffman.o \
        crctable.o \
        randtable.o \
        compress.o \
        decompress.o \
        bzlib.o

default: install

libbz2.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libbz2.a *.o *.bak

$(PREFIX)/lib/libbz2.a: libbz2.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/
	cp libbz2.a $(PREFIX)/lib/
	cp bzlib.h $(PREFIX)/include/

install: $(PREFIX)/lib/libbz2.a

depend:
	makedepend -Y -- \
        huffman.c \
        crctable.c \
        randtable.c \
        compress.c \
        decompress.c \
        bzlib.o 2> /dev/null

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

huffman.o: bzlib_private.h bzlib.h
crctable.o: bzlib_private.h bzlib.h
randtable.o: bzlib_private.h bzlib.h
compress.o: bzlib_private.h bzlib.h
decompress.o: bzlib_private.h bzlib.h

=== 3rdparty/openh264/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

VERSION = 2.0.0
OPENH264_EXTRA_MAKE_FLAGS ?=
ifeq ($(shell uname),Darwin)
OPENH264_EXTRA_MAKE_FLAGS += CFLAGS=-mmacosx-version-min=10.15
endif

ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell curl --version 2>/dev/null),)
DOWNLOAD_CMD := curl -k -OL
endif
endif
ifeq ($(DOWNLOAD_CMD),)
ifneq ($(shell wget --version 2>/dev/null),)
DOWNLOAD_CMD := wget --no-check-certificate
endif
endif
ifeq ($(DOWNLOAD_CMD),)
DOWNLOAD_CMD := echo "Error: Unable to find curl or wget."; exit 1; \#
endif

ifneq ($(shell nasm --version 2>/dev/null),)
ASM_OPTS := USE_ASM=Yes
else
ASM_OPTS := USE_ASM=No
endif

default: install

$(PREFIX)/src/libopenh264-$(VERSION).tar.gz:
	mkdir -p $(PREFIX)/src
	cd $(PREFIX)/src/ && $(DOWNLOAD_CMD) https://gr-framework.org/downloads/3rdparty/libopenh264-$(VERSION).tar.gz

$(PREFIX)/src/libopenh264-$(VERSION)/Makefile: $(PREFIX)/src/libopenh264-$(VERSION).tar.gz
	cd $(PREFIX)/src/ && tar -xf libopenh264-$(VERSION).tar.gz && mv openh264-$(VERSION) libopenh264-$(VERSION)
	touch $@

$(PREFIX)/lib/libopenh264.a: $(PREFIX)/src/libopenh264-$(VERSION)/Makefile
	$(MAKE) -j4 -C $(PREFIX)/src/libopenh264-$(VERSION) install-static $(ASM_OPTS) PREFIX=$(PREFIX) $(OPENH264_EXTRA_MAKE_FLAGS)

install: $(PREFIX)/lib/libopenh264.a

.PHONY: default install

=== 3rdparty/qhull/Makefile ===
ifeq ($(strip $(PREFIX)),)
override PREFIX = $(abspath $(CURDIR)/../build)
endif

 CFLAGS = -O -fPIC -fno-common $(ARCHS)
ifeq ($(shell uname),Darwin)
ifneq ($(notdir $(CC)),emcc)
CFLAGS += -mmacosx-version-min=10.15
endif
endif

   OBJS = \
        global_r.o \
        stat_r.o \
        geom2_r.o \
        poly2_r.o \
        merge_r.o \
        libqhull_r.o \
        geom_r.o \
        poly_r.o \
        qset_r.o \
        mem_r.o \
        random_r.o \
        usermem_r.o \
        userprintf_r.o \
        io_r.o \
        user_r.o \
        rboxlib_r.o \
        userprintf_rbox_r.o

default: install

libqhull_r.a: $(OBJS)
	$(AR) crv $@ $?
	$(AR) ts $@

distclean: clean

clean:
	rm -f libqhull_r.a *.o

$(PREFIX)/lib/libqhull_r.a: libqhull_r.a
	mkdir -p $(PREFIX)/lib/
	mkdir -p $(PREFIX)/include/libqhull_r
	cp libqhull_r.a $(PREFIX)/lib/
	cp *.h $(PREFIX)/include/libqhull_r/

install: $(PREFIX)/lib/libqhull_r.a

depend:
	makedepend -Y -- \
        global_r.c \
        stat_r.c \
        geom2_r.c \
        poly2_r.c \
        merge_r.c \
        libqhull_r.c \
        geom_r.c \
        poly_r.c \
        qset_r.c \
        mem_r.c \
        random_r.c \
        usermem_r.c \
        userprintf_r.c \
        io_r.c \
        user_r.c \
        rboxlib_r.c \
        userprintf_rbox_r.c 2> /dev/null

.PHONY: default install clean distclean depend

# DO NOT DELETE THIS LINE -- make depend depends on it.

global_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
global_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
stat_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
stat_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
geom2_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
geom2_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
poly2_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
poly2_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
merge_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
merge_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
libqhull_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
libqhull_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
geom_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
geom_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
poly_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
poly_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
qset_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
mem_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
random_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h random_r.h
usermem_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
userprintf_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h poly_r.h
io_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h random_r.h
io_r.o: geom_r.h merge_r.h poly_r.h io_r.h
user_r.o: qhull_ra.h libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h
user_r.o: random_r.h geom_r.h merge_r.h poly_r.h io_r.h
rboxlib_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h random_r.h
userprintf_rbox_r.o: libqhull_r.h user_r.h mem_r.h qset_r.h stat_r.h

=== lib/gr3/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../3rdparty/build)
endif

       GRDIR = /usr/local/gr
      LIBDIR = $(DESTDIR)$(GRDIR)/lib
      INCDIR = $(DESTDIR)$(GRDIR)/include

UNAME := $(shell uname)

    INCLUDES = -I$(THIRDPARTYDIR)/include -I../gr -I../gks
      GRLIBS = -L../gr -lGR
     PNGLIBS = $(THIRDPARTYDIR)/lib/libpng.a
    JPEGLIBS = $(THIRDPARTYDIR)/lib/libjpeg.a
       ZLIBS = $(THIRDPARTYDIR)/lib/libz.a
      CFLAGS = -O3 -Wall -Wextra -pedantic -fPIC -pthread -DGRDIR=\"$(GRDIR)\" $(EXTRA_CFLAGS)
        OBJS = gr3.o gr3_convenience.o gr3_html.o gr3_povray.o gr3_png.o \
               gr3_jpeg.o gr3_gr.o gr3_mc.o gr3_slices.o gr3_sr.o

ifeq ($(UNAME), Darwin)
GR_SHARED_LIBRARY_SUFFIX ?= .dylib
      CFLAGS+= -mmacosx-version-min=10.15
      GLLIBS = -framework OpenGL -framework Cocoa
        OBJS+= gr3_cgl.o
INSTALL_NAME = -Wl,-install_name,@rpath/libGR3${GR_SHARED_LIBRARY_SUFFIX}
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,@loader_path/. -mmacosx-version-min=10.15
     SOFLAGS = -dynamiclib
        LIBS =
else
GR_SHARED_LIBRARY_SUFFIX ?= .so
      GLLIBS =
PLATFORMLIBS = -lX11 -lGL
        OBJS+= gr3_glx.o
INSTALL_NAME =
     LDFLAGS = $(EXTRA_LDFLAGS) -Wl,-rpath,'$$ORIGIN/.'
     SOFLAGS = -shared
        LIBS = -ldl
endif

default:
	$(MAKE) -C ../.. Makedefs
	$(MAKE) `cat ../../Makedefs`

all: targets

targets: prerequisites libGR3${GR_SHARED_LIBRARY_SUFFIX}

prerequisites:
	$(MAKE) -C ../gr

ifeq ($(UNAME), $(filter $(UNAME),Linux FreeBSD))  # if $(UNAME) in (Linux, FreeBSD)
targets: libGR3platform.so
install: install_platform
install_platform:
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -r libGR3platform.so $(LIBDIR)
libGR3platform.so: gr3_platform_glx.c
	${CC} -o $@ $^ $(CFLAGS) $(INCLUDES) $(PLATFORMLIBS) $(SOFLAGS) $(LDFLAGS) $(GLDEFS)
endif

.c.o:
	${CC} -c $< $(CFLAGS) $(INCLUDES) $(GLDEFS)

libGR3${GR_SHARED_LIBRARY_SUFFIX}: $(OBJS)
	${CC} -o $@ $^ $(CFLAGS) $(JPEGLIBS) $(GLLIBS) $(GRLIBS) $(PNGLIBS) $(ZLIBS) $(LIBS) \
	$(SOFLAGS) $(LDFLAGS) $(INSTALL_NAME)

gr3.c: gr3.h gr3_internals.h gr3_sr.h
gr3_internals.h: gr3.h gr3_glx.h gr3_cgl.h
gr3_glx.c: gr3_glx.h
gr3_cgl.c: gr3_cgl.h
gr3_convenience.c: gr3_internals.h
gr3_html.c: gr3_internals.h
gr3_povray.c: gr3_internals.h
gr3_png.c: gr3_internals.h
gr3_jpeg.c: gr3_internals.h
gr3_gr.c: gr3_internals.h gr3_sr.h
gr3_mc.c: gr3.h gr3_mc_data.h
gr3_slices.c: gr3.h
gr3_sr.c: gr3_sr.h

install: targets
	@if [ ! -d $(DESTDIR)$(GRDIR) ]; then mkdir -m 755 $(DESTDIR)$(GRDIR); fi
	@if [ ! -d $(LIBDIR) ]; then mkdir -m 755 $(LIBDIR); fi
	cp -p libGR3${GR_SHARED_LIBRARY_SUFFIX} $(LIBDIR)
	@if [ ! -d $(INCDIR) ]; then mkdir -m 755 $(INCDIR); fi
	cp -p gr3.h $(INCDIR)

clean:
	$(MAKE) -C ../gr clean
	rm -rf libGR3${GR_SHARED_LIBRARY_SUFFIX}*
	rm -rf libGR3platform.so*
	rm -f *.o

=== lib/gks/plugin/Makefile ===
ifeq ($(strip $(THIRDPARTYDIR)),)
override THIRDPARTYDIR = $(abspath $(CURDIR)/../../../3rdparty/build)
endif

   UNAME := $(shell uname)

      GRDIR = /usr/local/gr
     LIBDIR = $(DESTDIR)$(GRDIR)/lib

     CFLAGS = -O -Wall -Wextra -pedantic -fPIC $(EXTRA_CFLAGS)
   CXXFLAGS = -O -Wall -Wextra -pedantic -Wno-deprecated-copy -fPIC $(EXTRA_CXXFLAGS) # -Wno-deprecated-copy to avoid warnings from wx headers
   INCLUDES = -I.. -I$(THIRDPARTYDIR)/include
    SOFLAGS = -shared
    LDFLAGS = $(EXTRA_LDFLAGS)
ifeq ($(UNAME),Darwin)
	 CFLAGS += -mmacosx-version-min=10.15
   CXXFLAGS += -mmacosx-version-min=10.15
	 LDFLAGS += -mmacosx-version-min=10.15
endif
  WX_CONFIG = false
     WXDEFS =
      WXINC = `$(WX_CONFIG) --cxxflags 2>/dev/null`
     WXLIBS = `$(WX_CONFIG) --libs 2>/dev/null`
ifneq ($(QT4_QMAKE),false)
     QT4DEFS =
   QT4INCDIR = `$(QT4_QMAKE) -query QT_INSTALL_HEADERS`
      QT4INC = -I$(QT4INCDIR) -I$(QT4INCDIR)/QtCore -I$(QT4INCDIR)/QtGui
   QT4LIBDIR = `$(QT4_QMAKE) -query QT_INSTALL_LIBS`
     QT4LIBS = -L$(QT4LIBDIR) -lQtGui -lQtCore
ifeq ($(UNAME),Darwin)
ifneq ($(QT4INC),)
     QT4INC += -mmacosx-version-min=10.15
endif
else
	EXTRA_LDFLAGS_QT4="-Wl,-rpath=$(QT4LIBDIR)"
endif
endif
ifneq ($(QT5_QMAKE),false)
     QT5DEFS =
   QT5INCDIR = `$(QT5_QMAKE) -query QT_INSTALL_HEADERS`
ifeq ($(UNAME),Darwin)
      QT5INC = -I$(QT5INCDIR) -I$(QT5LIBDIR)/QtCore.framework/Versions/5/Headers -I$(QT5LIBDIR)/QtGui.framework/Versions/5/Headers -I$(QT5LIBDIR)/QtWidgets.framework/Versions/5/Headers -F$(QT5LIBDIR)
else
      QT5INC = -I$(QT5INCDIR) -I$(QT5INCDIR)/QtCore -I$(QT5INCDIR)/QtGui -I$(QT5INCDIR)/QtWidgets
endif
   QT5INC += -std=c++11
   QT5LIBDIR = `$(QT5_QMAKE) -query QT_INSTALL_LIBS`
ifeq ($(UNAME),Darwin)
     QT5LIBS = -F$(QT5LIBDIR) -framework QtWidgets -framework QtGui -framework QtCore
else
     QT5LIBS = -L$(QT5LIBDIR) -lQt5Widgets -lQt5Gui -lQt5Core
	EXTRA_LDFLAGS_QT5="-Wl,-rpath=$(QT5LIBDIR)"
endif
endif
ifneq ($(QT6_QMAKE),false)
     QT6DEFS =
   QT6INCDIR = `$(QT6_QMAKE) -query QT_INSTALL_HEADERS`
ifeq ($(UNAME),Darwin)
      QT6INC = -I$(QT6INCDIR) -I$(QT6LIBDIR)/QtCore.framework/Versions/A/Headers -I$(QT6LIBDIR)/QtGui.framework/Versions/A/Headers -I$(QT6LIBDIR)/QtWidgets.framework/Versions/A/Headers -F$(QT6LIBDIR)
else
      QT6INC = -I$(QT6INCDIR) -I$(QT6INCDIR)/QtCore -I$(QT6INCDIR)/QtGui -I$(QT6INCDIR)/QtWidgets
endif
	QT6INC += -std=c++17
	QT6LIBDIR = `$(QT6_QMAKE) -query QT_INSTALL_LIBS`
ifeq ($(UNAME),Darwin)
     QT6LIBS = -F$(QT6LIBDIR) -framework QtWidgets -framework QtGui -framework QtCore
else
     QT6LIBS = -L$(QT6LIBDIR) -lQt6Widgets -lQt6Gui -lQt6Core
	EXTRA_LDFLAGS_QT6="-Wl,-rpath=$(QT6LIBDIR)"
endif
endif
 GTK_CONFIG = false
    GTKDEFS =
     GTKINC = `$(GTK_CONFIG) gtk+-2.0 --cflags 2>/dev/null`
    GTKLIBS = `$(GTK_CONFIG) gtk+-2.0 --libs 2>/dev/null`
   JPEGLIBS = $(THIRDPARTYDIR)/lib/libjpeg.a
    PNGLIBS = $(THIRDPARTYDIR)/lib/libpng.a
    BZ2LIBS = $(THIRDPARTYDIR)/lib/libbz2.a
     GSDEFS =
      GSINC =
     GSLIBS = -lgs
   GLFWDEFS =
    GLFWINC =
    GLFWLIB = glfw
ifeq ($(UNAME),Darwin)
   GLFWLIBS = -l$(GLFWLIB) -framework OpenGL -framework Cocoa -framework IOKit -framework CoreVideo
else
   GLFWLIBS = -l$(GLFWLIB) -lGL
endif
    XFTDEFS =
     FTDEFS =
     FTLIBS = $(THIRDPARTYDIR)/lib/libfreetype.a
     AVDEFS =
     AVLIBS = -lavformat -lavcodec -lswscale -lavutil $(BZ2LIBS)
  CAIRODEFS =
ifdef USE_STATIC_CAIRO_LIBS
  CAIROLIBS = $(THIRDPARTYDIR)/lib/libcairo.a $(THIRDPARTYDIR)/lib/libpixman-1.a
else
  CAIROLIBS = -lcairo -lpixman-1 -lpthread
endif
  AGGDEFS = -std=c++11
ifdef USE_STATIC_AGG_LIBS
  AGGLIBS = $(THIRDPARTYDIR)/lib/libagg.a
else
  AGGLIBS = -lagg
endif
    SSLLIBS = -lssl -lcrypto
    X11DEFS =
ifeq ($(UNAME), Darwin)
     X11INC = -I/opt/X11/include
else
     X11INC = -I/usr/X11R6/include
endif
    XFTLIBS = -lXft -lfontconfig
    X11LIBS = $(X11PATH) $(XFTLIBS) -lXt -lX11
    ZMQDEFS =
    ZMQLIBS = -L$(THIRDPARTYDIR)/lib/ -lzmq -lpthread
ifeq ($(UNAME), Darwin)
  EXTRALIBS = -framework VideoDecodeAcceleration -framework VideoToolbox -framework CoreVideo -framework CoreFoundation -framework CoreServices -framework CoreMedia
       LIBS = -liconv
else
  EXTRALIBS =
       LIBS = -lc -lm
endif
      ZLIBS = $(THIRDPARTYDIR)/lib/libz.a
   TIFFLIBS = -ltiff
    GKSLIBS = ../libGKS.a

.SUFFIXES: .o .m .cxx

.m.o:
	$(CXX) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(INCLUDES) $(CXXFLAGS) $<
.c.o:
	$(CC) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(CFLAGS) $(INCLUDES) $(GTKDEFS) $(GTKINC) $(GSDEFS) $(GSINC) $(GLFWDEFS) $(GLFWINC) $(ZMQDEFS) $(XFTDEFS) $(FTDEFS) $(FTINC) $(AVDEFS) $(CAIRODEFS) $(X11DEFS) $(X11INC) $(ZINC) $<
.cxx.o:
	$(CXX) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(CXXFLAGS) $(INCLUDES) $(WXDEFS) $(WXINC) $(QT4DEFS) $(QT4INC) $(GTKDEFS) $(GTKINC) $(GSDEFS) $(GSINC) $(GLFWDEFS) $(GLFWINC) $(ZMQDEFS) $(XFTDEFS) $(FTDEFS) $(FTINC) $(AVDEFS) $(CAIRODEFS) $(X11DEFS) $(X11INC) $(ZINC) $<

default:
	$(MAKE) -C ../../.. Makedefs
	$(MAKE) `cat ../../../Makedefs`

all: targets

targets: prerequisites \
         x11plugin.so wxplugin.so qtplugin.so qt5plugin.so qt6plugin.so \
         svgplugin.so gtkplugin.so gsplugin.so wmfplugin.so glplugin.so \
         zmqplugin.so pgfplugin.so cairoplugin.so videoplugin.so aggplugin.so

ifeq ($(UNAME),Darwin)
targets: quartzplugin.so
endif

prerequisites:
	$(MAKE) -C ../../../3rdparty PREFIX=$(THIRDPARTYDIR)

$(GKSLIBS):
	$(MAKE) -C .. libGKS.a

qtplugin.o: qtplugin.cxx
	$(CXX) -o $@ -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(WXDEFS) $(WXINC) $(QT4DEFS) $(QT4INC) $(GTKDEFS) $(GTKINC) $(GSDEFS) $(GSINC) $(GLFWDEFS) $(GLFWINC) $(ZMQDEFS) $(INCLUDES) $(XFTDEFS) $(FTDEFS) $(FTINC) $(AVDEFS) $(CAIRODEFS) $(X11DEFS) $(X11INC) $(CXXFLAGS) $(ZINC) $<

qt5plugin.o: qt5plugin.cxx
	$(CXX) -o $@ -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(WXDEFS) $(WXINC) $(QT5DEFS) $(QT5INC) $(GTKDEFS) $(GTKINC) $(GSDEFS) $(GSINC) $(GLFWDEFS) $(GLFWINC) $(ZMQDEFS) $(INCLUDES) $(XFTDEFS) $(FTDEFS) $(FTINC) $(AVDEFS) $(CAIRODEFS) $(X11DEFS) $(X11INC) $(CXXFLAGS) $(ZINC) $<

qt6plugin.o: qt6plugin.cxx
	$(CXX) -o $@ -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(WXDEFS) $(WXINC) $(QT6DEFS) $(QT6INC) $(GTKDEFS) $(GTKINC) $(GSDEFS) $(GSINC) $(GLFWDEFS) $(GLFWINC) $(ZMQDEFS) $(INCLUDES) $(XFTDEFS) $(FTDEFS) $(FTINC) $(AVDEFS) $(CAIRODEFS) $(X11DEFS) $(X11INC) $(CXXFLAGS) $(ZINC) $<

aggplugin.o: aggplugin.cxx
	$(CXX) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(CXXFLAGS) $(INCLUDES) $(FTDEFS) $(FTINC) $(AGGDEFS) $<

x11plugin.so: x11plugin.o $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(FTLIBS) $(ZLIBS) $(X11LIBS) $(LIBS)

wxplugin.so: wxplugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(WXLIBS) $(X11LIBS) $(LIBS)

qtplugin.so: qtplugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(EXTRA_LDFLAGS_QT4) $(QT4LIBS) $(X11LIBS) $(LIBS)

qt5plugin.so: qt5plugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(EXTRA_LDFLAGS_QT5) $(QT5LIBS) $(X11LIBS) $(LIBS)

qt6plugin.so: qt6plugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(EXTRA_LDFLAGS_QT6) $(QT6LIBS) $(X11LIBS) $(LIBS)

svgplugin.so: svgplugin.o $(GKSLIBS) $(PNGLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(PNGLIBS) $(ZLIBS) $(LIBS)

gtkplugin.so: gtkplugin.o $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(GTKLIBS) $(X11LIBS) $(LIBS)

gsplugin.so: gsplugin.o $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(GSLIBS) $(X11LIBS) $(LIBS)

wmfplugin.so: wmfplugin.o $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(LIBS)

quartzplugin.so: quartzplugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $^ $(LIBS) $(ZMQLIBS) \
	-lobjc -framework Foundation -framework ApplicationServices -framework AppKit

glplugin.so: glplugin.o $(GKSLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(GLFWLIBS) $(FTLIBS) $(ZLIBS) $(X11LIBS) $(LIBS)

zmqplugin.so: zmqplugin.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(ZMQLIBS) $(LIBS)

pgfplugin.so: pgfplugin.o $(GKSLIBS) $(PNGLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(PNGLIBS) $(ZLIBS) $(LIBS)

cairoplugin.o: cairoplugin.c
	$(CC) -c -DGRDIR=\"$(GRDIR)\" $(DEFINES) $(INCLUDES) $(FTDEFS) $(FTINC) $(JPEGDEFS) $(CAIRODEFS) $(TIFFDEFS) $(CFLAGS) $(ZINC) -DNO_X11 $<

cairoplugin.so: cairoplugin.o $(GKSLIBS) $(PNGLIBS)
	$(CC) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(CAIROLIBS) $(FTLIBS) $(JPEGLIBS) $(PNGLIBS) $(TIFFLIBS) $(ZLIBS) $(LIBS) -DNO_X11

videoplugin.so: videoplugin.o vc.o gif.o $(GKSLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(AVLIBS) $(FTLIBS) $(EXTRALIBS) $(ZLIBS) $(LIBS)

aggplugin.so: aggplugin.o $(GKSLIBS) $(PNGLIBS)
	$(CXX) -o $@ $(SOFLAGS) $(LDFLAGS) $^ $(AGGLIBS) $(FTLIBS) $(JPEGLIBS) $(PNGLIBS) $(EXTRALIBS) $(ZLIBS) $(LIBS)

install: default $(TARGETS)
	cp -p *.so $(LIBDIR)

clean:
	rm -f so_locations *.so *.o *.bak *~ *.tmp

qtplugin.o: qtplugin_impl.cxx
qt5plugin.o: qtplugin_impl.cxx
qt6plugin.o: qtplugin_impl.cxx

.PHONY: clean install default gks

=== PKGBUILD ===
# Maintainer: Sutou Kouhei <kou@clear-code.com>

_realname=gr
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.73.7
pkgrel=1
pkgdesc="A graphics library for visualisation applications (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://gr-framework.org/"
msys2_repository_url="https://github.com/sciapp/gr"
msys2_references=(
  'aur: gr-framework'
)
license=("spdx:MIT")
depends=("${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-fontconfig"
         "${MINGW_PACKAGE_PREFIX}-glfw"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/sciapp/gr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-support-mingw-wcstok.patch")
sha256sums=('2584727b1413a337ef14daae1e61bdc5c946403031695b42ecfbf8bc1888d132'
            'c3209d0ea7816b24549766cce3dabe21b81d1f4ddc9dd752b132a1db9c79f8be')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  # We can't use bsdtar to extract the archive because the archive includes
  # symbolic link.
  rm -rf "${_realname}-${pkgver}"
  tar -xf "${_realname}-${pkgver}.tar.gz" || true

  cd "${srcdir}/${_realname}-${pkgver}"

  # Set version manually, otherwise it resets to zero
  echo "${pkgver}" > version.txt
  sed -i "s|\${GR_VERSION}|${pkgver}|g" CMakeLists.txt

  patch -p1 -i "${srcdir}/0001-support-mingw-wcstok.patch"
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
    -G "Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DGR_USE_BUNDLED_LIBRARIES=OFF \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}
